/*M///////////////////////////////////////////////////////////////////////////////////////
//
//  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
//
//  By downloading, copying, installing or using the software you agree to this license.
//  If you do not agree to this license, do not download, install,
//  copy or use the software.
//
//
//                        Intel License Agreement
//                For Open Source Computer Vision Library
//
// Copyright (C) 2000, Intel Corporation, all rights reserved.
// Third party copyrights are property of their respective owners.
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
//   * Redistribution's of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//
//   * Redistribution's in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//
//   * The name of Intel Corporation may not be used to endorse or promote products
//     derived from this software without specific prior written permission.
//
// This software is provided by the copyright holders and contributors "as is" and
// any express or implied warranties, including, but not limited to, the implied
// warranties of merchantability and fitness for a particular purpose are disclaimed.
// In no event shall the Intel Corporation or contributors be liable for any direct,
// indirect, incidental, special, exemplary, or consequential damages
// (including, but not limited to, procurement of substitute goods or services;
// loss of use, data, or profits; or business interruption) however caused
// and on any theory of liability, whether in contract, strict liability,
// or tort (including negligence or otherwise) arising in any way out of
// the use of this software, even if advised of the possibility of such damage.
//
//M*/

// avsrDemoDoc.cpp : implementation of the CAvsrDemoDoc class
//

#include "stdafx.h"
#include "avsrDemo.h"
#include "mainfrm.h"

#include "avsrDemoDoc.h"
#include "avsrdemoview.h"

#include "VHMMDecoder.h"
#include "AHMMDecoder.h"
#include "CHMMDecoder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
///////////////////////////////////////////////////////////////////////////////////////////////
	float m_pfAudioWeight[40] = { 0.8f,		0.8f,	0.85f,	0.9f,	0.95f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,					
							  1.0f,		1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,
							  1.0f,		1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,
							  1.0f,		1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	1.0};

	float m_pfVisualWeight[40] = {1.0f,		1.0f,	1.0f,	1.0f,	1.0f,	1.0f,	0.95f,	0.9f,	0.85f,	0.8f,
							  0.8f,		0.8f,	0.8f,	0.8f,	0.8f,	0.8f,	0.7f,	0.6f,	0.5f,	0.5f,
							  0.5f,		0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,
							  0.5f,		0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5f,	0.5};

	
//////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CAvsrDemoDoc

IMPLEMENT_DYNCREATE(CAvsrDemoDoc, CDocument)

BEGIN_MESSAGE_MAP(CAvsrDemoDoc, CDocument)
	//{{AFX_MSG_MAP(CAvsrDemoDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAvsrDemoDoc construction/destruction
		
CAvsrDemoDoc::CAvsrDemoDoc()
{
	// TODO: add one-time construction code here
	m_szAviList.RemoveAll();

	m_pDisplayVideo=NULL;
	m_pWave=NULL;
	m_fSNR = 5;
	
	m_szPcaMatrixFile[0]=0;
	m_szLdaMatrixFile[0]=0;	
	m_szNoiseWaveFile[0]=0;
	m_szVisualOnlyCfg[0]=0;
	m_szAudioOnlyCfg[0]=0;
	m_szAvsrCfg[0]=0;
	
	m_nTotalWE_Vsr = m_nTotalWE_Asr = m_nTotalWE_Avsr = m_nTotalWordNum = 0;

	m_pHaarMouthTracker = NULL;
	m_phidCascadeFace = NULL;
	m_phidCascadeMouth0 = NULL;
	m_phidCascadeMouth1 = NULL;
	m_pReference = NULL;
	Empty2StrArray(m_visualAlign);
	Empty2StrArray(m_audioAlign);
	Empty2StrArray(m_avsrAlign);
	
	m_isAviLoaded = false;
	
	m_bPcaFileLoaded = false;
	m_pmatPcaMeanVector = NULL;
	m_pmatPcaEigenValue = NULL;
	m_pmatPcaEigenVector = NULL;
	
	m_bLdaFileLoaded = false;
	m_pmatLdaMeanVector = NULL;
	m_pmatLdaSdevVector = NULL;
	m_pmatLdaTransformMatrix = NULL;
	m_pmatLdaEigenvalue = NULL;

	m_nAudioMfccDimension = 13;			// fixed
}

CAvsrDemoDoc::~CAvsrDemoDoc()
{
	m_szAviList.RemoveAll();

	if (m_pDisplayVideo != NULL)
		delete m_pDisplayVideo;
	if (m_pWave != NULL)
		delete m_pWave;
	FreeSpeechModules();
	ReleaseStrArray(m_pReference);
	if (m_pReference != NULL) 
		delete  m_pReference;
	Release2StrArray(&m_visualAlign);
	Release2StrArray(&m_audioAlign);
	Release2StrArray(&m_avsrAlign);
}

BOOL CAvsrDemoDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	POSITION pos = GetFirstViewPosition();
	CAvsrDemoView *pView = (CAvsrDemoView*)GetNextView(pos);
	CDC *pDC = pView->GetDC();
	HDC hDC = pDC->GetSafeHdc();
	SetBkColor(hDC,RGB(64,104,242));

	// (SDI documents will reuse this document)
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAvsrDemoDoc serialization

void CAvsrDemoDoc::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAvsrDemoDoc diagnostics

#ifdef _DEBUG
void CAvsrDemoDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAvsrDemoDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAvsrDemoDoc commands

void CAvsrDemoDoc::OnFileOpen() 
{
	// TODO: Add your command handler code here
	POSITION pos = GetFirstViewPosition();
	CAvsrDemoView *pView = (CAvsrDemoView*)GetNextView(pos);
	if (pView->m_isPlaying)
	{
		AfxMessageBox("The last avi is still playing, please wait for a while!\nIn <CAvsrDemoDoc::OnFileOpen()>.");
		return;
	}
	CFileDialog fileOpen(true,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Avi Files(*.avi)|*.avi");
	if (fileOpen.DoModal()!=IDOK) return;
	
	strcpy(m_szAvsrCfg, fileOpen.GetPathName().Left(fileOpen.GetPathName().GetLength()-fileOpen.GetFileName().GetLength())+"DemoConfig.cfg");
	LoadConfigFile(m_szAvsrCfg);

	if (!InitSpeechModules()) 
	{
		AfxMessageBox("Fail to load configure file!\nIn <CAvsrDemoDoc::OnFileOpen()>.");
		return;
	}
	
	// load AVI file list
	char szAviFile[1024];
	strcpy(szAviFile,fileOpen.GetPathName());
	int nHot = LoadAviFileList(szAviFile);
	if (nHot >= 0) {
		pView->SetFileList(m_szAviList, nHot);
	}

	if(LoadTestData(szAviFile))
		m_isAviLoaded = true;	
}

void CAvsrDemoDoc::OnReset() 
{	
	m_nTotalWE_Asr = 0;
	m_nTotalWE_Vsr = 0;
	m_nTotalWE_Avsr = 0;
	m_nTotalWordNum = 0;
	POSITION pos = GetFirstViewPosition();
	CAvsrDemoView *pView = (CAvsrDemoView*)GetNextView(pos);
	pView->m_isShowStack = true;
	pView->isShowResult = false;
	pView->m_isShowScript = true;
	pView->m_isShowLastFrame = true;
	pView->Invalidate();
}

void CAvsrDemoDoc::SetStatusText(CString szText)
{
	CMainFrame *pFrame = (CMainFrame*)(AfxGetMainWnd());
	pFrame->m_wndStatusBar.SetPaneText(0,szText);
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: SpeechRecognition
//    Purpose:
//		  All the processes of audio-only, visual-only and audio-visual speech recognition
//    Parameters:
//    Returns: 
//F*/
void CAvsrDemoDoc::SpeechRecognition()
{
	// All the algorithms are embedded here!
	POSITION pos = GetFirstViewPosition();
	CAvsrDemoView *pView = (CAvsrDemoView*)GetNextView(pos);
	pView->m_isShowLastFrame=false;
	
	////////////////////////////////////////////////
	// Mouth Tracking
	////////////////////////////////////////////////
	SetStatusText("Mouth tracking...");

	// get the setting of the progress bar
	int nUpper,nLow;	
	pView->m_pcrtProgress.GetRange(nLow,nUpper);
	int nRange = nUpper - nLow;
	
	// get video information
	int nImageWidth, nImageHeight, nImageBand, nFrameNum;
	float fFrameRate;
	if (!m_aviContainer.GetVideoInfo(nImageWidth, nImageHeight, nImageBand, nFrameNum, fFrameRate)) 
	{
		AfxMessageBox("Invalid video data!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");		
		return;
	}	

	// allocate image buffer for displaying mouth tracking result	
	IplImage *iplShowImage = cvCreateImage(cvSize(pView->m_nAviDisplayWidth, pView->m_nAviDisplayHeight), IPL_DEPTH_8U, nImageBand);
	if (iplShowImage == NULL) 
	{
		AfxMessageBox("Can't allocate buffer for image displaying!\nInsufficent memory!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		return;
	}

	// tracking result
	CvMouthLocateResult result;
	CvMouthLocateResult *pMouthResultArray = new CvMouthLocateResult[nFrameNum];
	if (pMouthResultArray == NULL) 
	{
		AfxMessageBox("Can't allocate buffer for mouth tracking results!\nInsufficent memory!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		cvReleaseImage(&iplShowImage);
		return;
	}

	// reset tracking
	if( cvResetTrackMouth(nImageWidth, nImageHeight, m_pHaarMouthTracker) != CV_StsOk)
	{
		AfxMessageBox("Fail to reset mouth tracker!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		cvReleaseImage(&iplShowImage);
		delete pMouthResultArray;
		return;
	}

	// Tracking
	float fZoomRate = (float)pView->m_nAviDisplayWidth / (float)nImageWidth;
	// temporary image
	IplImage *iplFrame;
	int i,j;
	for (i=0; i<nFrameNum; i++) 
	{
		// get source image
		iplFrame = m_aviContainer.GetImage(i);
		if (iplFrame == NULL || iplFrame->width != nImageWidth || iplFrame->height != nImageHeight)
		{
			AfxMessageBox("Fail to get video data or invalid video data!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
			cvReleaseImage(&iplShowImage);
			delete pMouthResultArray;
			return;
		}

		// detect mouth region
		CvTrackResult TResult;
		if( cvUpdateTrackMouth(iplFrame, m_pHaarMouthTracker, TResult) != CV_StsOk)
		{
			AfxMessageBox("Fail to check one frame of input video!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
			cvReleaseImage(&iplShowImage);
			delete pMouthResultArray;
			return;
		}
		if (TResult.TrackRltSts != TRACKSUCCESSFUL)
		{
			CString serror;
			CString serrortype;
			switch (TResult.TrackRltSts)
			{
			case FACEDETECTERROR:
				serrortype = "Face detection error"; break;
			case MOUTHTRACKERROR:
				serrortype = "Mouth tracking error"; break;
			case MOUTHDETECTERROR:
				serrortype = "Mouth detection error"; break;
			}
			serror.Format("Mouth tracking...  (Warning : track error at frame %d, error type : %s)",i,serrortype);
			SetStatusText(serror);
		}

		// set result
		pMouthResultArray[i] = TResult.MouthResult;
		memcpy(iplShowImage->imageData, &(m_pDisplayVideo[i*iplShowImage->imageSize]), iplShowImage->imageSize);
		CvRect face, mouth;		
		if (TResult.TrackRltSts == TRACKSUCCESSFUL) 
		{
			mouth.x = cvRound((TResult.MouthResult.CenterX - TResult.MouthResult.Width / 2) * fZoomRate);
			mouth.width = cvRound(TResult.MouthResult.Width * fZoomRate);
			mouth.y = cvRound((TResult.MouthResult.CenterY - TResult.MouthResult.Height / 2) * fZoomRate);
			mouth.height = cvRound(TResult.MouthResult.Height * fZoomRate);
			face.x = cvRound(TResult.MouthResult.face_left * fZoomRate);
			face.width = cvRound((TResult.MouthResult.face_right - TResult.MouthResult.face_left) * fZoomRate);
			face.y = cvRound(TResult.MouthResult.face_top * fZoomRate);
			face.height = cvRound((TResult.MouthResult.face_bottom - TResult.MouthResult.face_top) * fZoomRate);
			pView->MakeResultImage(iplShowImage, &face, &mouth);
		}
		// show current result
		pView->ShowSingleImage(iplShowImage);
		// set process bar
		pView->m_pcrtProgress.SetPos(i*nRange/(nFrameNum*4)+nLow);
	}

	// post process
	SetStatusText("Postprocessing...");
	Sleep(200);
	if ( cvPostProcessTrackMouth(pMouthResultArray, nFrameNum) != CV_StsOk )
		SetStatusText("Warning: Mouth tracking failed!");

	// show video with mouth region rectangle again
	for (i=0; i<nFrameNum; i++) 
	{
		result = pMouthResultArray[i];
		memcpy(iplShowImage->imageData, &(m_pDisplayVideo[i*iplShowImage->imageSize]), iplShowImage->imageSize);
		CvRect mouth1;
		mouth1.x = cvRound((result.CenterX - result.Width / 2) * fZoomRate);
		mouth1.width = cvRound(result.Width * fZoomRate);
		mouth1.y = cvRound((result.CenterY - result.Height / 2) * fZoomRate);
		mouth1.height = cvRound(result.Height * fZoomRate);
		pView->MakeResultImage(iplShowImage, NULL, &mouth1);
		// show current result
		pView->ShowSingleImage(iplShowImage);
		// set process bar
		pView->m_pcrtProgress.SetPos(nRange/4+i*nRange/(nFrameNum*12)+nLow);
		Sleep(5);
	}

	// ---------------------------------------------------
	// Mouth Region Extraction
	// ---------------------------------------------------	
	// set stadard mouth region size
	const int nStdWidth = 32;
	const int nStdHeight = 32;	
	// allocate mouth region array
	IplImage **iplMouthRegion = new IplImage*[nFrameNum];
	for(i=0;i<nFrameNum;i++)
	{
		iplMouthRegion[i] = cvCreateImage(cvSize(nStdWidth, nStdHeight), IPL_DEPTH_8U, 1);
		if (iplMouthRegion[i] == NULL)
		{
			AfxMessageBox("Can't allocate memory for mouth region!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
			for(j=0;j<i;j++)
				cvReleaseImage(&iplMouthRegion[i]);
			delete pMouthResultArray;
			return;
		}	
	}	
	// extract mouth region
	for (i=0; i<nFrameNum; i++) 
	{
		// get one frame and convert to gray image
		iplFrame = m_aviContainer.GetImage(i);
		IplImage *iplGrayFrame = cvCreateImage(cvSize(iplFrame->width, iplFrame->height), IPL_DEPTH_8U, 1);
		if(iplGrayFrame == NULL)
		{
			AfxMessageBox("Can't allocate memory for gray image convertion!\nNot enough memory!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
			return;
		}
		cvCvtColor( iplFrame, iplGrayFrame, CV_BGR2GRAY );
		CvMouthLocateResult result = pMouthResultArray[i];
		// modify the ROI shape to squre
		result.Height = result.Width;
		// mouth region extraction
		// set mouth region to be roi of source image
		CvRect rltROI;
		rltROI.x = cvRound(result.CenterX - result.Width / 2.0f);
		rltROI.width = cvRound(result.Width);
		rltROI.y = cvRound(result.CenterY - result.Height / 2.0f);
		rltROI.height = cvRound(result.Height);
		cvSetImageROI(iplGrayFrame, rltROI);
		if (!NormalizeMouthRegion((const IplImage *)iplGrayFrame, true, true, iplMouthRegion[i]))
			SetStatusText("Warning: Mouth region extraction failed!\n");
		cvReleaseImage(&iplGrayFrame);
	}
	delete pMouthResultArray;

	// --------------------------------------------------
	// Audio Feature Extraction
	// --------------------------------------------------
	SetStatusText("Audio feature extraction...");	

	// get audio information
	int nAudioFrameNum, nAudioSampleSize, nAudioSampleRate;
	BYTE *ptemp = m_aviContainer.GetAudioData(nAudioFrameNum, nAudioSampleSize, nAudioSampleRate);
	if(ptemp == NULL)
	{
		AfxMessageBox("Fail to get audio data!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		return;
	}
	int nAudioLength = nAudioFrameNum * nAudioSampleSize / sizeof(short);
	
	// Extract Audio Feature
	int nAudioFeatureNum = 100 * (nAudioLength / nAudioSampleRate + 2);
	float *pAudioMfcc = new float [nAudioFeatureNum * m_nAudioMfccDimension];
	//if (!AudioFrontEndProcess(m_pWave, nAudioLength, nAudioSampleRate, 200, pAudioMfcc, nAudioFeatureNum)) 
	if (!ExtractMFCC(m_pWave, nAudioLength, pAudioMfcc, nAudioFeatureNum, nAudioSampleRate)) 
	{
		AfxMessageBox("Fail to extract audio feature!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		delete pAudioMfcc;
		return;
	}
	// set progress status
	pView->m_pcrtProgress.SetPos(nRange/2+nLow);
	
	// --------------------------------------------------
	// Visual Feature Extraction
	// --------------------------------------------------
	SetStatusText("Visual feature extraction...");
	// allocate visual output buffer	
	float fUpsampleRate = 100 / fFrameRate;
	int nVisualFeatureNum = cvRound(fUpsampleRate*nFrameNum);
	int nLdadimension = m_pmatLdaTransformMatrix->rows;
	CvMat *pmatVisualOut = cvCreateMat(nVisualFeatureNum, nLdadimension, CV_32F);
	if (pmatVisualOut == NULL) 
	{		
		AfxMessageBox("Can't allocate buffer for visual output!\nNot enough memory!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		delete pAudioMfcc;
		return;
	}
	// extracting feature	
	if (!VisualFrontEndFeatureExtract((const IplImage **)iplMouthRegion, nFrameNum, 32, fUpsampleRate, true, 7, 5000.0f, pmatVisualOut)) 
	{
		for(i=0;i<nFrameNum;i++)
			cvReleaseImage(&iplMouthRegion[i]);
		delete iplMouthRegion;
		delete pAudioMfcc;
		cvReleaseMat(&pmatVisualOut);
		AfxMessageBox("Visual feature extraction failed!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		return;
	}
	// release buffer
	for(i=0;i<nFrameNum;i++)
		cvReleaseImage(&iplMouthRegion[i]);
	delete iplMouthRegion;
	// set progress status
	pView->m_pcrtProgress.SetPos(nRange*2/3+nLow);

	// --------------------------------------------------
	// ASR, VSR and AVSR Recognition
	// --------------------------------------------------
	// Audio-only Recognition
	SetStatusText("Audio-only speech recognition...");
	char szAResult[AVSR_DEMO_MAX_RESULT_LENGTH];
	memset(szAResult, 0, AVSR_DEMO_MAX_RESULT_LENGTH);
	int err_flag = ahmm_decoder_rec(pAudioMfcc, m_nAudioMfccDimension, nAudioFeatureNum, szAResult, AVSR_DEMO_MAX_RESULT_LENGTH);
	if (err_flag)
	{
		AfxMessageBox("An error occurs in A-HMM decoder!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		return;
	}
	pView->m_pcrtProgress.SetPos(nRange*3/4+nLow);

	// Visual-only Recognition
	SetStatusText("Video-only speech recognition...");
	char szVResult[AVSR_DEMO_MAX_RESULT_LENGTH];
	memset(szVResult, 0, AVSR_DEMO_MAX_RESULT_LENGTH);
	err_flag = vhmm_decoder_rec(pmatVisualOut->data.fl, pmatVisualOut->cols, pmatVisualOut->rows, szVResult, AVSR_DEMO_MAX_RESULT_LENGTH);
	if (err_flag) 
	{
		AfxMessageBox("An error occurs in V-HMM decoder!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		SetStatusText("Cancel the processing.");
		return;
	}
	pView->m_pcrtProgress.SetPos(nRange*5/6+nLow);

	// AVSR Recognition
	SetStatusText("Audio-visual speech recognition...");
	char szAvsrResult[AVSR_DEMO_MAX_RESULT_LENGTH];
	memset(szAvsrResult, 0, AVSR_DEMO_MAX_RESULT_LENGTH);
	// set weight
	int nSnr = (int)(m_fSNR / 2.0f);			// convert SNR(bubble ) to SNR(Gaussian)
	if (nSnr > 40) {
		chmm_decoder_set_weight(1.0f, 0.3f);	//(float audioW, float VisualW);
	}else if (nSnr < 0) {
		chmm_decoder_set_weight(0.3f, 1.0f);	//(float audioW, float VisualW);
	}else {
		chmm_decoder_set_weight(m_pfAudioWeight[nSnr], m_pfVisualWeight[nSnr]);
	}
	
	// decode
	int nMinFrameNum = nVisualFeatureNum < nAudioFeatureNum ? nVisualFeatureNum : nAudioFeatureNum;
	err_flag = chmm_decoder_rec(pAudioMfcc, pmatVisualOut->data.fl, m_nAudioMfccDimension, nLdadimension, nMinFrameNum, szAvsrResult, AVSR_DEMO_MAX_RESULT_LENGTH);
	if (err_flag) 
	{
		AfxMessageBox("An error occurs in C-HMM decoder!\nIn <CAvsrDemoDoc::SpeechRecognition()>.");
		return;
	}

	cvReleaseMat(&pmatVisualOut);
	delete pAudioMfcc;
	pView->m_pcrtProgress.SetPos(nUpper);
	SetStatusText("Result evaluation...");

	// --------------------------------------------------
	// evalute results
	// --------------------------------------------------
	int nWordNum = m_pReference->num;
	m_nTotalWordNum += nWordNum;	
	STR_ARRAY *pVideoOnly = FormatResult(szVResult);
	STR_ARRAY *pAudioOnly = FormatResult(szAResult);
	STR_ARRAY *pAvsrResult = FormatResult(szAvsrResult);

	int nVisualAcc, nVisualIns, nVisualDel, nVisualSub;
	int nAudioAcc, nAudioIns, nAudioDel, nAudioSub;
	int nAvsrAcc, nAvsrIns, nAvsrDel, nAvsrSub;
	Release2StrArray(&m_visualAlign);
	Release2StrArray(&m_audioAlign);
	Release2StrArray(&m_avsrAlign);
	DoWordAlignment(*pVideoOnly, *m_pReference, &m_visualAlign, nVisualAcc, nVisualIns, nVisualDel, nVisualSub);
	int nVisualWE = nVisualIns + nVisualDel + nVisualSub;
	m_nTotalWE_Vsr += nVisualWE;
	DoWordAlignment(*pAudioOnly, *m_pReference, &m_audioAlign, nAudioAcc, nAudioIns, nAudioDel, nAudioSub);
	int nAudioWE = nAudioIns + nAudioDel + nAudioSub;
	m_nTotalWE_Asr += nAudioWE;
	DoWordAlignment(*pAvsrResult, *m_pReference, &m_avsrAlign, nAvsrAcc, nAvsrIns, nAvsrDel, nAvsrSub);
	int nAvsrWE = nAvsrIns + nAvsrDel + nAvsrSub;
	m_nTotalWE_Avsr += nAvsrWE;
	
	// release string array of result
	ReleaseStrArray(pVideoOnly);
	if (pVideoOnly != NULL) 
		delete pVideoOnly;
	ReleaseStrArray(pAudioOnly);
	if (pAudioOnly != NULL) 
		delete pAudioOnly;
	ReleaseStrArray(pAvsrResult);
	if (pAvsrResult != NULL) 
		delete pAvsrResult;
	
	pView->m_isNext=true;
	pView->isShowResult=true;
	pView->m_isSleep=true;
	pView->m_isShowStack=true;
	pView->m_isShowLastFrame=true;

	pView->Invalidate(false);

	return;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: LoadAviFileList
//    Purpose:
//		  Load all the AVI file names in one folder
//    Parameters:
//		  szFile ---- [I] one AVI file name in the folder
//    Returns: 
//		  The index of the current file, -1 for failure
//F*/
int CAvsrDemoDoc::LoadAviFileList(const char *szFile)
{
	CFileFind find;	
	BOOL isFound = find.FindFile(szFile);
	isFound=find.FindNextFile();
	m_szAviPath=find.GetFilePath().Left(find.GetFilePath().GetLength()-find.GetFileName().GetLength());
	
	isFound=find.FindFile(m_szAviPath+"*.avi");
	CString szAvi;
	int nAviNum=0;
	m_szAviList.RemoveAll();
	while (isFound)
	{
		isFound=find.FindNextFile();
		if (find.IsDirectory())
		{
			continue;
		}
		if (find.IsDots())
		{
			continue;
		}
		m_szAviList.Add(find.GetFileName());
		nAviNum ++;
		if (strcmp(szFile,find.GetFilePath())==0)
		{
			szAvi=find.GetFileName();
		}
	}
	// sort file name
	CString compare;
	int j,k;
	for (j=0;j<nAviNum;j++)
	{
		for (k=0;k<j;k++)
		{
			if (strcmp(m_szAviList[k],m_szAviList.GetAt(j))>0)
			{
				compare=m_szAviList.GetAt(k);
				m_szAviList.SetAt(k, m_szAviList.GetAt(j));
				m_szAviList.SetAt(j, compare);
			}
		}
	}
	// identify the current file
	int nIndex=-1;
	for (j=0;j<nAviNum;j++)
	{
		if (strcmp(szAvi,m_szAviList.GetAt(j))==0)
		{
			nIndex=j;
		}
	}

	return nIndex;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: LoadMouthTracker
//    Purpose:
//		  Load the mouth tracking modules
//    Parameters:
//		  szFileName ---- [I] configure file for mouth tracking
//    Returns: 
//F*/
bool CAvsrDemoDoc::LoadMouthTracker(const char * szFileName)
{
	CvHaarClassifierCascade* cascade = NULL;
	CvHaarClassifierCascade* cascade0 = NULL;
	CvHaarClassifierCascade* cascade1 = NULL;

	char HaarBaseSamplePath[MAX_PATH_LEN];
	char HaarBasePath0[MAX_PATH_LEN];
	char HaarBasePath1[MAX_PATH_LEN];
	
	if (szFileName == NULL) 
	{
		AfxMessageBox("Could not open option file!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");
		return false;
	} 

	// face detector path
	if (GetPrivateProfileString("MOUTHTRACK", "HAARSAMPLEBASEPATH", "haarbase", HaarBaseSamplePath, MAX_PATH_LEN, szFileName) <=0) 
		return false;

	// load face model
	if (m_phidCascadeFace != NULL)
	{
		cvReleaseHidHaarClassifierCascade(&m_phidCascadeFace);
		m_phidCascadeFace = NULL;
	}
    cascade = cvLoadHaarClassifierCascade(HaarBaseSamplePath, cvSize(ORIG_WIN_SIZE, ORIG_WIN_SIZE));
    if( cascade == NULL ) 
	{
		AfxMessageBox("Could not locate face classifier base!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");
		return false;
	}    
	m_phidCascadeFace = cvCreateHidHaarClassifierCascade( cascade );
    cvReleaseHaarClassifierCascade( &cascade );
	if (m_phidCascadeFace == NULL) 
	{
		AfxMessageBox("Can not create HID Cascade!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");
		cvReleaseHaarClassifierCascade( &cascade );
		return false;
	}

	// mouth detector path
	if (GetPrivateProfileString("MOUTHTRACK", "DUALCASCADEPATH0", "mouth32_norm", HaarBasePath0, MAX_PATH_LEN, szFileName) <= 0) 
		return false;
	if (GetPrivateProfileString("MOUTHTRACK", "DUALCASCADEPATH1", "mouth32_beard", HaarBasePath1, MAX_PATH_LEN, szFileName) <= 0) 
		return false;
	
	if (HaarBasePath0 == NULL || HaarBasePath1 == NULL) 
	{
		AfxMessageBox("Invalid input argument!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");	
		return false;
	}

	// load classifier 0	
    cascade0 = cvLoadHaarClassifierCascade(HaarBasePath0, cvSize(32, 28));
    if( cascade0 == NULL ) 
	{
		AfxMessageBox("Could not locate mouth classifier base!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");		
		return false;
	}

    m_phidCascadeMouth0 = cvCreateHidHaarClassifierCascade( cascade0 );
    cvReleaseHaarClassifierCascade( &cascade0 );
	if (m_phidCascadeMouth0 == NULL) 
	{
		AfxMessageBox("Can not create HID Cascade 0!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");		
		return false;
	}

	// load classifier 1
	cascade1 = cvLoadHaarClassifierCascade(HaarBasePath1, cvSize(32, 28));
    if( cascade1 == NULL ) 
	{
		AfxMessageBox("Could not locate mouth classifier base!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");		
		return false;
	}
	
    m_phidCascadeMouth1 = cvCreateHidHaarClassifierCascade( cascade1 );
    cvReleaseHaarClassifierCascade( &cascade1 );
	if (m_phidCascadeMouth1 == NULL) 
	{
		AfxMessageBox("Can not create HID Cascade 1!\nIn <CAvsrDemoDoc::LoadMouthTracker()>.");		
		return false;
	}

	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: LoadConfigFile
//    Purpose:
//		  Load the demo configuration file
//    Parameters:
//		  szAviFile ---- [I] config file name
//    Returns: 
//F*/
bool CAvsrDemoDoc::LoadConfigFile(const char *szConfigFile)
{
	FILE *fp = fopen(szConfigFile, "rt");
	if (fp == NULL) 
	{
		AfxMessageBox("Can't open configure file!\nIn <CAvsrDemoDoc::LoadConfigFile()>.");
		return false;
	}

	char szLine[1024];

	if (fgets(szLine, 1023, fp) == NULL) return false;					// [Mouth Track]
	if (fgets(szLine, 1023, fp) == NULL) return false;
	sscanf(szLine, "Configure Filename = %s\n", m_szMouthTrackCfg);		// Configure Filename = MouthTrackSetting.cfg
	if (fgets(szLine, 1023, fp) == NULL) return false;					// blank line

	if (fgets(szLine, 1023, fp) == NULL) return false;					// [Front End]
	if (fgets(szLine, 1023, fp) == NULL) return false;					// PCA Data File   = PCA_32.pca
	sscanf(szLine, "PCA Data File   = %s\n", m_szPcaMatrixFile);
	if (fgets(szLine, 1023, fp) == NULL) return false;					// LDA Data File   = Pca32_Ups_FMN.lda
	sscanf(szLine, "LDA Data File   = %s\n", m_szLdaMatrixFile);
	
	if (fgets(szLine, 1023, fp) == NULL) return false;					// Noise Wave File = digits.wav
	sscanf(szLine, "Noise Wave File = %s\n", m_szNoiseWaveFile);
	if (fgets(szLine, 1023, fp) == NULL) return false;					// blank line

	if (fgets(szLine, 1023, fp) == NULL) return false;					// [Visual Only]
	if (fgets(szLine, 1023, fp) == NULL) return false;					// Configure Filename = VHMMConfig.cfg
	sscanf(szLine, "Configure Filename = %s\n", m_szVisualOnlyCfg);
	if (fgets(szLine, 1023, fp) == NULL) return false;					// blank line

	if (fgets(szLine, 1023, fp) == NULL) return false;					// [Audio Only]
	if (fgets(szLine, 1023, fp) == NULL) return false;					// Configure Filename = AHMMConfig.cfg
	sscanf(szLine, "Configure Filename = %s\n", m_szAudioOnlyCfg);
	if (fgets(szLine, 1023, fp) == NULL) return false;					// blank line

	if (fgets(szLine, 1023, fp) == NULL) return false;					// [AVSR]
	if (fgets(szLine, 1023, fp) == NULL) return false;
	sscanf(szLine, "Configure Filename = %s\n", m_szAvsrCfg);			// Configure Filename = CHMMConfig.cfg

	fclose(fp);

	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: LoadTestData
//    Purpose:
//		  Load the AVSR test data including the AVI file and the transcript file, then
//		  generate the image sequence for display
//    Parameters:
//		  szAviFile ---- [I] AVI file name
//    Returns: 
//F*/
bool CAvsrDemoDoc::LoadTestData(const char *szAviFile)
{
	CMainFrame *pFrame = (CMainFrame*)AfxGetMainWnd();
	pFrame->m_wndStatusBar.SetPaneText(0,"Loading file "+CString(szAviFile)+" ...");

	POSITION pos = GetFirstViewPosition();
	CAvsrDemoView *pView = (CAvsrDemoView*)GetNextView(pos);

	char szLabelFile[1024];
	GetScriptFilename(szAviFile, szLabelFile,"txt");

	// delete old buffer
	if (m_pDisplayVideo != NULL) 
	{
		delete m_pDisplayVideo;
		m_pDisplayVideo = NULL;
	}
	if (m_pWave != NULL) 
	{
		delete m_pWave;
		m_pWave = NULL;
	}

	// read video and audio data
	if (!m_aviContainer.LoadAvi(szAviFile, true, true))
	{
		AfxMessageBox("Load avi data file failed!\nPlease load a valid format avi file!\nIn <CAvsrDemoDoc::LoadTestData()>.");
		return false;
	}
	
	// get video information
	int nImageWidth, nImageHeight, nImageBand, nVideoFrameNum;
	float fVideofFrameRate;
	if(!m_aviContainer.GetVideoInfo(nImageWidth, nImageHeight, nImageBand, nVideoFrameNum, fVideofFrameRate)){
		AfxMessageBox("Get video info failed!\nIn <CAvsrDemoDoc::LoadTestData()>.");
		return false;
	}
	
	// get audio information
	int nAudioFrameNum, nAudioSampleSize, nAudioSampleRate;
	BYTE *ptemp = m_aviContainer.GetAudioData(nAudioFrameNum, nAudioSampleSize, nAudioSampleRate);
	if(ptemp == NULL)
	{
		AfxMessageBox("Get audio data failed!\nIn <CAvsrDemoDoc::LoadTestData()>.");		
		return false;
	}
	
	// allocate audio buffer for adding noise
	m_pWave = new short[nAudioFrameNum * nAudioSampleSize / sizeof(short)];
	if(m_pWave == NULL)
	{
		AfxMessageBox("Can't allocate audio buffer for adding noise!\nInsufficent memory!\nIn <CAvsrDemoDoc::LoadTestData()>.");
		m_aviContainer.ClearAvi();
		return false;
	}
	
	// allocate video buffer for displaying
	LONG ldisplayvideosize = pView->m_nAviDisplayWidth*pView->m_nAviDisplayHeight*nImageBand*nVideoFrameNum;
	m_pDisplayVideo = new BYTE[ldisplayvideosize];
	if(m_pDisplayVideo == NULL)
	{
		AfxMessageBox("Can't allocate quarter video buffer!\nInsufficent memory!\nIn <CAvsrDemoDoc::LoadTestData()>.");
		m_aviContainer.ClearAvi();
		delete m_pWave;
		return false;
	}
	
	// reflect and downsample source image
	IplImage *iplReflecImage = cvCreateImage(cvSize(nImageWidth,nImageHeight), IPL_DEPTH_8U, nImageBand);
	if(iplReflecImage == NULL)
	{
		AfxMessageBox("Can't allocate flipped image buffer!\nInsufficent memory!\nIn <CAvsrDemoDoc::LoadTestData()>.");
		m_aviContainer.ClearAvi();
		delete m_pWave;
		return false;
	}
	IplImage *iplDownSampleImage = cvCreateImage(cvSize(pView->m_nAviDisplayWidth, pView->m_nAviDisplayHeight), IPL_DEPTH_8U, nImageBand);
	if(iplDownSampleImage == NULL)
	{
		AfxMessageBox("Can't allocate quarter flipped frame buffer!\nInsufficent memory!\nIn <CAvsrDemoDoc::LoadTestData()>.");
		m_aviContainer.ClearAvi();
		delete m_pWave;
		cvReleaseImage(&iplReflecImage);
		return false;
	}
	IplImage *iplSrcFrame;
	for (int i=0;i<nVideoFrameNum;i++)
	{
		iplSrcFrame = m_aviContainer.GetImage(i);
		if(iplSrcFrame == NULL)
		{
			AfxMessageBox("Can't get image from video!\nIn <CAvsrDemoDoc::LoadTestData()>.");
			m_aviContainer.ClearAvi();
			delete m_pWave;
			cvReleaseImage(&iplReflecImage);
			cvReleaseImage(&iplDownSampleImage);
			return false;
		}
		// reflect
		for (int j=0;j<nImageHeight;j++)
		{
			memcpy(&(iplReflecImage->imageData[(nImageHeight-1-j)*iplReflecImage->widthStep]),
				   &(iplSrcFrame->imageData[j*iplSrcFrame->widthStep]), iplSrcFrame->widthStep);
		}
		// down sample		
		cvResize(iplReflecImage, iplDownSampleImage);
		if (i==0)
		{
			pView->SetLastFrame(iplDownSampleImage);
		}
		memcpy(m_pDisplayVideo+i*iplDownSampleImage->imageSize,iplDownSampleImage->imageData,iplDownSampleImage->imageSize);
	}
	cvReleaseImage(&iplReflecImage);
	cvReleaseImage(&iplDownSampleImage);
	iplSrcFrame = NULL;

	//initialize avi player
	pView->m_aviPlayer.SetVideoRate(fVideofFrameRate);

	WAVEFORMATEX wvFm;
	wvFm.wFormatTag = 1;
	wvFm.nChannels = 1;
	wvFm.nSamplesPerSec = nAudioSampleRate;
	wvFm.nBlockAlign= nAudioSampleSize;
	wvFm.nAvgBytesPerSec = nAudioSampleRate * nAudioSampleSize;
	wvFm.wBitsPerSample = 8 * wvFm.nBlockAlign;
	wvFm.cbSize = 0;
	pView->m_aviPlayer.Initialize((long)&wvFm);
	
	int x=pView->m_rectPlayer.left;
	int y=pView->m_rectPlayer.top;
	pView->m_aviPlayer.SetWindowPos(pView,x,y,x+357,y+285,0);
	pView->m_aviPlayer.SetAudioRate(nAudioSampleRate);
	pView->m_aviPlayer.SetVideoData((long)m_pDisplayVideo,nVideoFrameNum,pView->m_nAviDisplayWidth,pView->m_nAviDisplayHeight);
	pView->m_aviPlayer.SetBuffer(40);
	pView->isShowResult=false;
	pView->m_isShowScript=true;

	// load transcript file
	ReleaseStrArray(m_pReference);
	if (m_pReference != NULL) 
		delete  m_pReference;
	m_pReference = LoadScriptFile(szLabelFile);

	pView->m_isDone=false;
	pView->m_isSleep=true;
	pView->Invalidate();

	pFrame->m_wndStatusBar.SetPaneText(0,"Ready");

	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: FreeSpeechModules
//    Purpose:
//		  Initialize all the modules used in speech recognition
//    Parameters:
//    Returns: 
//F*/
bool CAvsrDemoDoc::InitSpeechModules()
{
	// create mouth tracking module	
	m_pHaarMouthTracker = new CvMouthTracker;
	
	// load mouth tracking options
	if (!LoadMouthTracker(m_szMouthTrackCfg)) 
		return false;
	
	// use cvInitTrackMouth to initialize mouth tracker
	cvInitTrackMouth(m_phidCascadeFace, m_phidCascadeMouth0, m_phidCascadeMouth1, m_pHaarMouthTracker);
	
	// Initialize front-end module
	if (!VisualFrontEndInitial(m_szPcaMatrixFile, m_szLdaMatrixFile)) 
	{
		AfxMessageBox("Can't initialize visual front-end module!\nIn <CAvsrDemoDoc::InitSpeechModules()>.");
		return false;
	}
	
	if (!InitMFCC()) 
	{
		AfxMessageBox("Can't initialize audio front-end module!\nIn <CAvsrDemoDoc::InitSpeechModules()>.");
		VisualFrontEndUninitial();
		return false;
	}

	// Initialize Visual Only module
	int err_flag;
	err_flag = vhmm_decoder_init(m_szVisualOnlyCfg);
	if(err_flag) 
	{
		AfxMessageBox("Fail to initialize the visual-only decoder, error code = %d\nIn <CAvsrDemoDoc::InitSpeechModules()>.", err_flag);
		return false;
	}

	// Initialize Audio Only module
	err_flag = ahmm_decoder_init(m_szAudioOnlyCfg);
	if(err_flag) 
	{
		AfxMessageBox("Fail to initialize the audio-only decoder, error code = %d\nIn <CAvsrDemoDoc::InitSpeechModules()>.", err_flag);
		return false;
	}

	// Initialize AVSR module
	err_flag = chmm_decoder_init(m_szAvsrCfg);
	if(err_flag) 
	{
		AfxMessageBox("Fail to initialize the AVSR CHMM decoder, error code = %d\nIn <CAvsrDemoDoc::InitSpeechModules()>.", err_flag);
		return false;
	}

	// Initialize AddNoise module
	if (!m_addNoise.SetNoise(m_szNoiseWaveFile)) 
	{
		AfxMessageBox("Fail to load noise wave file!\nIn <CAvsrDemoDoc::InitSpeechModules()>.");
		return false;
	}

	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: FreeSpeechModules
//    Purpose:
//		  Release all the modules used in speech recognition
//    Parameters:
//    Returns: 
//F*/
void CAvsrDemoDoc::FreeSpeechModules(void)
{
	// release mouth tracker
	if (m_pHaarMouthTracker != NULL) 
	{
		cvReleaseTrackMouth(m_pHaarMouthTracker);
		delete m_pHaarMouthTracker;
	}
	// release front-end module
	VisualFrontEndUninitial();
	ReleaseMFCC();

	// Release Visual Only module
	vhmm_decoder_free();

	// Release Audio Only module
	ahmm_decoder_free();

	// Release Visual Only module
	chmm_decoder_free();

	return;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: NormalizeMouthRegion
//    Purpose:
//		  Normalize the mouth region images
//    Parameters:
//		  iplSrcGrayImage ---- [I] source image with gray scale
//        bHistEqu ---- [I] if apply the histogram equalization
//        bIgc ---- [I] if apply the IGC
//        iplRegionImage ---- [O] result region images
//    Returns: 
//		  return true if extracted successfully, else return false.
//F*/
bool CAvsrDemoDoc::NormalizeMouthRegion(const IplImage *iplSrcGrayImage, const bool bHistEqu, const bool bIgc, IplImage *iplRegionImage)
{
	if (iplSrcGrayImage == NULL || iplSrcGrayImage->width < 1 || iplSrcGrayImage->height < 1 ) 
	{
		AfxMessageBox("Invalid input image!\nIn <CAvsrDemoDoc::NormalizeMouthRegion()>.");
		return false;
	}
	
	if (iplSrcGrayImage->nChannels != 1) 
	{
		AfxMessageBox("Input image must be gray image!\nIn <CAvsrDemoDoc::NormalizeMouthRegion()>.");
		return false;
	}
	
	if (iplRegionImage == NULL || iplRegionImage->width < 1 || iplRegionImage->height < 1) 
	{
		AfxMessageBox("Invalid output image buffer!\nIn <CAvsrDemoDoc::NormalizeMouthRegion()>.");
		return false;
	}

	// use cvResize to extract roi of source image 
	// and resample it into standard region image
	cvResize(iplSrcGrayImage, iplRegionImage);
	
	// use cvEqualizeHist to do gray scale normalizing of extracting result	
	if (bHistEqu) 
	{	
		if (cvEqualizeHist(iplRegionImage) != CV_StsOk) 
		{
			AfxMessageBox("Histogram equalization failed!\nIn <CAvsrDemoDoc::NormalizeMouthRegion()>.");
			return false;
		}
	}
	// use cvNormalizeIllum to GIC extracting result  
	if (bIgc) 
	{
		const float	fNormedMean = 128.0f;	// destation mean value of the MSE normalization
		const float	fNormedMse = 64.0f;		// destation MSE of the MSE normalization
		if(cvNormalizeIllum(iplRegionImage, fNormedMean, fNormedMse) != CV_StsOk)
		{
			AfxMessageBox("GIC failed!\nIn <CAvsrDemoDoc::NormalizeMouthRegion()>.");
			return false;
		}
	}

	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: VisualFrontEndInitial
//    Purpose:
//		  Initialize the visual front-end module
//    Parameters:
//		  szPcaFile ---- [I] PCA transform matrix file name
//        szLdaFile ---- [I] LDA transform matrix file name
//    Returns: 
//		  return true if initialized successfully.
//        if any load error occurs then return false.
//F*/
bool CAvsrDemoDoc::VisualFrontEndInitial(const char *szPcaFile, const char *szLdaFile)
{
	// load PCA file
	if (szPcaFile == NULL || szPcaFile[0] == 0) 
	{
		m_bPcaFileLoaded = false;
	}
	else 
	{
		CString stFilePath(szPcaFile);
		int nLen = stFilePath.GetLength();
		int nInd = stFilePath.ReverseFind('.');
		CString stFileExt = stFilePath.Right(nLen-nInd-1);
		stFileExt.MakeLower();
		if (stFileExt == "pca") 
		{
			if (!m_featureIo.LoadEigenMatrix(szPcaFile, &m_pmatPcaMeanVector, &m_pmatPcaEigenValue, &m_pmatPcaEigenVector, false)) 
				return false;
		}
		else 
		{
			if (!m_featureIo.LoadEigenMatrix(szPcaFile, &m_pmatPcaMeanVector, &m_pmatPcaEigenValue, &m_pmatPcaEigenVector, true)) 
				return false;
		}
		m_bPcaFileLoaded = true;
	}

	// Load LDA file
	if (szLdaFile == NULL || szLdaFile[0] == 0) 
	{
		m_bLdaFileLoaded = false;
	}
	else 
	{
		if (!m_featureIo.LoadLdaMatrix( szLdaFile, &m_pmatLdaMeanVector, &m_pmatLdaSdevVector, 
									   &m_pmatLdaEigenvalue, &m_pmatLdaTransformMatrix, false))
			return false;
		m_bLdaFileLoaded = true;
	}

	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: VisualFrontEndFeatureExtract
//    Purpose:
//		  extract visual features from the mouth region images
//    Parameters:
//		  piplImageArray --- [I] mouth region images
//        nFrameNum		---- [I] number of the images
//        nPcaOutDim	---- [I] Dimension of the PCA subspace
//        fUpsampleRate ---- [I] upsample rate for visual features
//        bDoFMN		---- [I] whether to do feature mean normlization
//        nConWindowRadius - [I] window radius for feature concatenation
//        fFactor		---- [I] multiplier factor used in LDA projection
//        pmatOutput	---- [O] output visual features
//    Returns: 
//		  return true if extracted successfully, else return false.
//F*/
bool CAvsrDemoDoc::VisualFrontEndFeatureExtract(const IplImage **piplImageArray, const int nFrameNum, 
												const int nPcaOutDim, const float fUpsampleRate, 
												const bool bDoFMN, const int nConWindowRadius, 
												const float fFactor, CvMat* pmatOutput)
{
	if (*piplImageArray == NULL || (*piplImageArray)->width < 1 || (*piplImageArray)->height < 1 )
	{
		AfxMessageBox("Invalid input image sequence!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}
	
	if((*piplImageArray)->nChannels != 1)
	{
		AfxMessageBox("Input image must be gray image!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}

	if( nFrameNum < 1 || fUpsampleRate < 1.0f || nConWindowRadius < 1) 
	{
		AfxMessageBox("Invalid input parameter!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}

	if (!CV_IS_MAT(pmatOutput) || pmatOutput->rows < 1 || pmatOutput->cols < 1) 
	{
		AfxMessageBox("Invalid output data buffer or setting!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}
	int nOutputDim = pmatOutput->cols;
	int nFeatureNum = pmatOutput->rows;
	
	// PCA
	if (!m_bPcaFileLoaded) 
	{
		AfxMessageBox("PCA projection matrix is not loaded!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}

	if (nPcaOutDim > m_pmatPcaEigenVector->rows) 
	{
		AfxMessageBox("Invalid PCA projection dimension setting!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}

	int nImageHeight = (*piplImageArray)->height;
	int nImageWidth = (*piplImageArray)->width;
	int nImageSize = nImageHeight * nImageWidth;
	if (m_pmatPcaEigenVector->cols != nImageSize) 
	{
		AfxMessageBox("The input image sequence does not match the PCA matrix!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		return false;
	}
	// allocate pca output buffer
	CvMat *pmatPcaOutput = cvCreateMat(nFrameNum, nPcaOutDim, CV_32F);
	if (pmatPcaOutput == NULL) 
	{
		AfxMessageBox("Can't allocate buffer for PCA output!\nNot enough memory!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");	
		return false;
	}
	// use cvPCAProjection to do pca projection 
	// for input mouth region image array 
	if(cvPCAProjection(piplImageArray, nFrameNum, m_pmatPcaEigenValue, m_pmatPcaEigenVector, m_pmatPcaMeanVector, 
		pmatPcaOutput, false) != CV_StsOk)
	{
		cvReleaseMat(&pmatPcaOutput);
		return false;
	}		

	// Upsampling
	// allocate upsample buffer	
	CvMat *pmatUpsample = cvCreateMat(nFeatureNum, nPcaOutDim, CV_32F);
	if (pmatUpsample == NULL) 
	{
		AfxMessageBox("Can't allocate buffer for upsampling output!\nNot enough memory!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		cvReleaseMat(&pmatPcaOutput);
		return false;
	}
	// use cvInterpolateFT to do pca output vectors upsampling
	if(cvInterpolateFT(pmatPcaOutput, fUpsampleRate, pmatUpsample) != CV_StsOk)
	{
		cvReleaseMat(&pmatPcaOutput);
		cvReleaseMat(&pmatUpsample);
		return false;
	}

	// use cvNormalizeMean to do feature mean normalization of upsampled vectors 
	if(bDoFMN && cvNormalizeMean(pmatUpsample) != CV_StsOk)
	{
		cvReleaseMat(&pmatPcaOutput);
		cvReleaseMat(&pmatUpsample);
		return false;
	}
	cvReleaseMat(&pmatPcaOutput);

	// Concatenation
	// allocate concatenation buffer
	int nConcatVecLen = nPcaOutDim * (2 * nConWindowRadius + 1);
	CvMat *pmatConcatOut = cvCreateMat(nFeatureNum, nConcatVecLen, CV_32F);
	if (pmatConcatOut == NULL) 
	{
		AfxMessageBox("Can't allocate buffer for Concatenation output!\nNot enough memory!\nIn <CAvsrDemoDoc::VisualFrontEndFeatureExtract()>.");
		cvReleaseMat(&pmatUpsample);
		return false;
	}
	// use cvConcatVectors to do concatenation of upsampled frames
	int nWindowWidth = 2*nConWindowRadius+1;
	if(cvConcatVectors(pmatUpsample, nWindowWidth, pmatConcatOut) != CV_StsOk){		
		cvReleaseMat(&pmatUpsample);
		cvReleaseMat(&pmatConcatOut);
		return false;
	}
	cvReleaseMat(&pmatUpsample);
	
	// LDA
	// use cvLDAProjection to do lda transform
	if(cvLDAProjection(m_pmatLdaTransformMatrix, pmatConcatOut, pmatOutput) != CV_StsOk)
	{
		cvReleaseMat(&pmatConcatOut);
		return false;
	}
	cvReleaseMat(&pmatConcatOut);
	
	int i;
	if (cvGetElemType(pmatOutput) == CV_32F) 
	{
		for (i=0; i<pmatOutput->cols*pmatOutput->rows; i++)
			pmatOutput->data.fl[i] *= fFactor;
	}
	else 
	{
		for (i=0; i<pmatOutput->cols*pmatOutput->rows; i++)
			pmatOutput->data.db[i] *= fFactor;
	}
	
	return true;
}

/*F///////////////////////////////////////////////////////////////////////////////////////
//
//    Name: VisualFrontEndUninitial
//    Purpose:
//		  release the visual front-end module
//    Returns: 
//		  return true if released successfully, else return false.
//F*/
bool CAvsrDemoDoc::VisualFrontEndUninitial()
{	
	// release PCA matrix
	if (m_bPcaFileLoaded)
	{
		if (m_pmatPcaMeanVector != NULL)
			cvReleaseMat(&m_pmatPcaMeanVector);
		if (m_pmatPcaEigenValue != NULL)
			cvReleaseMat(&m_pmatPcaEigenValue);
		if (m_pmatPcaEigenVector != NULL)
			cvReleaseMat(&m_pmatPcaEigenVector);
		m_bPcaFileLoaded = false;
	}

	// release LDA matrix
	if (m_bLdaFileLoaded) 
	{
		if (m_pmatLdaEigenvalue != NULL)
			cvReleaseMat(&m_pmatLdaEigenvalue);
		if (m_pmatLdaTransformMatrix != NULL)
			cvReleaseMat(&m_pmatLdaTransformMatrix);
		if (m_pmatLdaMeanVector != NULL)
			cvReleaseMat(&m_pmatLdaMeanVector);
		if (m_pmatLdaSdevVector != NULL)
			cvReleaseMat(&m_pmatLdaSdevVector);
		m_bLdaFileLoaded = false;
	}

	return true;
}

void CAvsrDemoDoc::GetResult(TWO_STR_ARRAY *&visual,TWO_STR_ARRAY *&audio,TWO_STR_ARRAY *&avsr)
{
	visual=&m_visualAlign;
	audio=&m_audioAlign;
	avsr=&m_avsrAlign;
}

