/*M///////////////////////////////////////////////////////////////////////////////////////
//
//  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
//
//  By downloading, copying, installing or using the software you agree to this license.
//  If you do not agree to this license, do not download, install,
//  copy or use the software.
//
//
//                        Intel License Agreement
//                For Open Source Computer Vision Library
//
// Copyright (C) 2000, Intel Corporation, all rights reserved.
// Third party copyrights are property of their respective owners.
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
//   * Redistribution's of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//
//   * Redistribution's in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//
//   * The name of Intel Corporation may not be used to endorse or promote products
//     derived from this software without specific prior written permission.
//
// This software is provided by the copyright holders and contributors "as is" and
// any express or implied warranties, including, but not limited to, the implied
// warranties of merchantability and fitness for a particular purpose are disclaimed.
// In no event shall the Intel Corporation or contributors be liable for any direct,
// indirect, incidental, special, exemplary, or consequential damages
// (including, but not limited to, procurement of substitute goods or services;
// loss of use, data, or profits; or business interruption) however caused
// and on any theory of liability, whether in contract, strict liability,
// or tort (including negligence or otherwise) arising in any way out of
// the use of this software, even if advised of the possibility of such damage.
//
//M*/

// avsrDemoView.h : interface of the CAvsrDemoView class
//
/////////////////////////////////////////////////////////////////////////////
//{{AFX_INCLUDES()
#include "aviplayer.h"
//}}AFX_INCLUDES

#if !defined(AFX_AVSRDEMOVIEW_H__30668D64_DA2C_4722_A1BC_076EBDC77F5D__INCLUDED_)
#define AFX_AVSRDEMOVIEW_H__30668D64_DA2C_4722_A1BC_076EBDC77F5D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CAvsrDemoView : public CFormView
{
protected: // create from serialization only
	CAvsrDemoView();
	DECLARE_DYNCREATE(CAvsrDemoView)

public:
	//{{AFX_DATA(CAvsrDemoView)
	enum { IDD = IDD_AVSRDEMO_FORM };
	CAVIPlayer	m_aviPlayer;
	CListCtrl	m_cAviList;
	CButton	m_cBatch;
	CButton	m_cNoise;
	CButton	m_cStop;
	CButton	m_cStart;
	CButton	m_cReset;
	CStatic	m_cPlayer;
	CSliderCtrl	m_cNoiseSlider;
	CButton	m_cVsrStack;
	CButton	m_cAvsrStack;
	CButton	m_cAsrStack;
	CProgressCtrl	m_pcrtProgress;
	CStatic	m_stScript;
	CStatic	m_stAVSR;
	CStatic	m_stASR;
	CStatic	m_stVSR;
	CString	m_szAvsrError;
	CString	m_szVsrError;
	CString	m_szAsrError;
	int		m_nNoise;
	float	m_fSNR;
	BOOL	isShowResult;
	BOOL	m_isBatch;
	BOOL	m_isNoise;
	//}}AFX_DATA

// Attributes
public:
	CAvsrDemoDoc* GetDocument();
	CRect m_recTranscript;
	CRect m_recASRResult;
	CRect m_recVSRResult;
	CRect m_recAVSRResult;
	CRect m_recAvsrStack;
	CRect m_recAsrStack;
	CRect m_recVsrStack;
	CRect m_rectPlayer;
	BOOL  m_isSleep;
	BOOL  m_isShowScript;
	BOOL  m_isBatchStopped;
	bool m_isPlaying;
	bool m_isDone;
	bool m_isShowStack;
	bool m_isNext;
	bool m_isShowLastFrame;	
	IplImage *m_iplLastFrame;
	int m_nRunDemoTimer;
	int m_nOpenAviTimer;
	int m_nNextAviTimer;
	// avi display window size
	int m_nAviDisplayWidth; 
	int m_nAviDisplayHeight;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAvsrDemoView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL
// Implementation
public:
	void SetFileList(CStringArray &files, int nHot);
	void CalcControllerPos();
	void ProcessNext();
	void DisableController(bool toBeDisabled);
	void SetLastFrame(IplImage *iplImage);
	void Stop();
	void Start();
	bool MakeResultImage(IplImage *iplShowImage, CvRect *pFace, CvRect *pMouth);
	void ShowSingleImage(IplImage *iplShowImage);
	void DrawStack(CDC *pDC);
	char *Arab2English(char *szArab);
	void DrawResult(CDC* pDC);
	virtual ~CAvsrDemoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAvsrDemoView)
	afx_msg void OnStart();
	afx_msg void OnStop();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCheckNoise();
	afx_msg void OnDblclkListAvi(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg LRESULT OnDrawEnd(WPARAM, LPARAM);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in avsrDemoView.cpp
inline CAvsrDemoDoc* CAvsrDemoView::GetDocument()
   { return (CAvsrDemoDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AVSRDEMOVIEW_H__30668D64_DA2C_4722_A1BC_076EBDC77F5D__INCLUDED_)
