/*M///////////////////////////////////////////////////////////////////////////////////////
//
//  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
//
//  By downloading, copying, installing or using the software you agree to this license.
//  If you do not agree to this license, do not download, install,
//  copy or use the software.
//
//
//                        Intel License Agreement
//                For Open Source Computer Vision Library
//
// Copyright (C) 2000, Intel Corporation, all rights reserved.
// Third party copyrights are property of their respective owners.
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
//   * Redistribution's of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//
//   * Redistribution's in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//
//   * The name of Intel Corporation may not be used to endorse or promote products
//     derived from this software without specific prior written permission.
//
// This software is provided by the copyright holders and contributors "as is" and
// any express or implied warranties, including, but not limited to, the implied
// warranties of merchantability and fitness for a particular purpose are disclaimed.
// In no event shall the Intel Corporation or contributors be liable for any direct,
// indirect, incidental, special, exemplary, or consequential damages
// (including, but not limited to, procurement of substitute goods or services;
// loss of use, data, or profits; or business interruption) however caused
// and on any theory of liability, whether in contract, strict liability,
// or tort (including negligence or otherwise) arising in any way out of
// the use of this software, even if advised of the possibility of such damage.
//
//M*/

#ifndef _AVSR_DEMO_COMPARE_RESULT
#define _AVSR_DEMO_COMPARE_RESULT

typedef struct _string_array{
	char **stra;
	int *start;
	int *end;
	int  num;
} STR_ARRAY;

typedef struct _two_string_array{
	char **str_a;
	int *start_a;
	int *end_a;
	int num_a;
	char **str_b;
	int *start_b;
	int *end_b;
	int num_b;
	int num;
} TWO_STR_ARRAY;

enum edits {DEL,SUB,INS};

void GetScriptFilename(const char *szSrcFile, char *szDataFile, const char *szEx);

STR_ARRAY *LoadScriptFile(char szFilename[]);

STR_ARRAY *FormatResult(char szResult[]);

void ReleaseStrArray(STR_ARRAY *pRef);

void Release2StrArray(TWO_STR_ARRAY *result);

void Empty2StrArray(TWO_STR_ARRAY &result);

int DoWordAlignment(STR_ARRAY hyp_array, STR_ARRAY ref_array, TWO_STR_ARRAY *align_result,
					int &accuracy, int &insert_num, int &delete_num, int &sub_num);

#endif		// #define _AVSR_DEMO_COMPARE_RESULT

